<?php

namespace Apps\Asso\Widget\AssoMemberForm;

use Core\Control\Form\Form;
use Core\View\View;
use Core\View\ElementView;

class AssoMemberForm extends Form {

    /**
     * Constructeur
     */
    function __construct($core = "", $data = "") {
        $this->Core = $core;
        $this->Data = $data;

        $this->Init($data);
    }

    /**
     * Initialisation 
     */
    function Init($data) {
        $this->form = new Form("AssoMemberFormForm", $data);

        $this->form->SetView(__DIR__ . "/View/index.tpl", $this->Core);
        $this->form->SetAction("/View/index.tpl");

        $this->form->Add(array("Type" => "Hidden",
            "Id" => "Id",
        ));
        
        $this->form->Add(array("Type" => "TextBox",
            "Id" => "FirstName",
            "Validators" => ["Required"]
        ));
        
        $this->form->Add(array("Type" => "TextBox",
            "Id" => "Name",
            "Validators" => ["Required"]
        ));

        $this->form->Add(array("Type" => "EmailBox",
            "Id" => "Email",
        ));
        
        $this->form->Add(array("Type" => "TelBox",
            "Id" => "Phone",
        ));


        $this->form->Add(array("Type" => "EntityListBox",
        "Id" => "MemberTypeId",
        "Entity" => "\Apps\Asso\Entity\AssoMemberType",  
        "Field" => "Name",
        "Validators" => ["Required"]
    ));

        $this->form->Add(array("Type" => "TextBox",
            "Id" => "Adress",
        ));

        $this->form->Add(array("Type" => "TextBox",
        "Id" => "ZipCode",
    ));

    $this->form->Add(array("Type" => "TextBox",
        "Id" => "City",
    ));

    $this->form->Add(array("Type" => "DateBox",
    "Id" => "BirthDate",
    ));

    $this->form->Add(array("Type" => "Button",
            "Id" => "btnSaveMember",
            "Value" => $this->Core->GetCode("Base.SaveMember"),
            "CssClass" => "btn btn-primary"
        ));
    }

    /*     * *
     * Render the html form
     */

    function Render() {
        return $this->form->Render();
    }

    /*     * *
     * Validate the data
     */

    function Validate($data = "") {
        $errors = $this->form->Validate($this->Data);

        return $errors;
    }

    /*     * *
     * Load control with the entity
     */

    function Load($entity) {
        $this->form->Load($entity);
    }

    /*     * *
     * Populate the entity with the form Data
     */

    function Populate($entity) {
        
    }

    /*     * *
     * Error message
     */

    function Error() {
        $errors[] = $this->form->errors;

        return json_encode(array("statut" => "Error", "message" => $errors));
    }

}
